diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index 1d6b2589..80aad588 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -8,6 +8,22 @@ require "hive/task"
 class ClaudeLauncherTest < Minitest::Test
   include HiveTestHelper
 
+  # First capture_pane_tail call returns busy; every subsequent call returns
+  # idle. Matches a real pane that is busy on poll 1 and settled by poll 2
+  # (capture_limit_tail and any ready re-check within a poll share the
+  # current snapshot once production reuses pane_tail).
+  def busy_then_idle_runner(busy, idle)
+    Struct.new(:busy, :idle) do
+      def name = "hive-test-session"
+      def session_exists? = true
+
+      def capture_pane_tail(bytes:)
+        @n = (@n || 0) + 1
+        @n == 1 ? busy : idle
+      end
+    end.new(busy, idle)
+  end
+
   def test_headless_mode_delegates_to_base_spawn_agent
     with_tmp_task do |task|
       captured = nil
@@ -131,10 +147,13 @@ class ClaudeLauncherTest < Minitest::Test
           "effort" => "medium"
         }
       }
+      signal_resets = 0
 
       with_replaced_singleton_method(Hive::ClaudeLauncher, :build_runner, ->(**) { runner }) do
         with_replaced_singleton_method(Hive::ClaudeLauncher, :preflight!, ->(*) { }) do
-          with_replaced_singleton_method(Hive::ClaudeLauncher, :reset_signal_files, ->(*) { }) do
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :reset_signal_files, lambda { |_task|
+            signal_resets += 1
+          }) do
             with_replaced_singleton_method(Hive::StopHookInstaller, :install, ->(**) { [] }) do
               with_replaced_singleton_method(Hive::ClaudeLauncher, :wrapper_command, lambda { |**kwargs|
                 captured_flags = kwargs.fetch(:cli_flags)
@@ -166,6 +185,8 @@ class ClaudeLauncherTest < Minitest::Test
       end
 
       assert_equal %w[--model sonnet --effort medium], captured_flags
+      assert_equal 2, signal_resets,
+                   "shared-session setup and teardown must both clear .done and result.json"
     end
   end
 
@@ -1048,17 +1069,19 @@ class ClaudeLauncherTest < Minitest::Test
 
   def test_wait_for_status_dispatches_exit_output_and_unknown_modes
     with_tmp_task do |task|
-      runner = Struct.new(:tail) do
-        def capture_pane_tail(bytes:) = tail
-      end.new("Claude Code\n❯")
+      busy = "Claude Code\nworking…\n"
+      idle = "Claude Code\n❯"
       output = File.join(task.folder, "expected.md")
       File.write(output, "done")
+      runner = busy_then_idle_runner(busy, idle)
 
-      output_result = Hive::ClaudeLauncher.wait_for_status(
-        task, runner, 0, :output_file_exists, output, "reviewer"
-      )
-      assert_equal :ok, output_result.fetch(:status)
-      assert_equal "reviewer", output_result.fetch(:log_label)
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :poll_interval, -> { 0.01 }) do
+        output_result = Hive::ClaudeLauncher.wait_for_status(
+          task, runner, 10, :output_file_exists, output, "reviewer"
+        )
+        assert_equal :completion_candidate, output_result.fetch(:status)
+        assert_equal "reviewer", output_result.fetch(:log_label)
+      end
     end
 
     with_tmp_task do |task|
@@ -1067,6 +1090,7 @@ class ClaudeLauncherTest < Minitest::Test
       end.new("")
       missing_output = File.join(task.folder, "missing.md")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
 
       done_result = Hive::ClaudeLauncher.wait_for_status(
         task, runner, 0, :exit_code_only, missing_output, "ci"
@@ -1080,17 +1104,65 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
-  def test_wait_for_expected_output_accepts_ready_prompt_without_done_file
+  def test_wait_for_expected_output_returns_completion_candidate_after_busy_to_idle
+    with_tmp_task do |task|
+      output = File.join(task.folder, "result.md")
+      File.write(output, "review findings")
+      busy = "Claude Code v2\nworking…\n"
+      idle = "Claude Code v2\n\n/home/project  ❯"
+      runner = busy_then_idle_runner(busy, idle)
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :poll_interval, -> { 0.01 }) do
+        result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
+
+        assert_equal :completion_candidate, result.fetch(:status)
+        assert_equal "review", result.fetch(:log_label)
+        evidence = result.fetch(:completion_evidence)
+        assert_equal true, evidence.fetch(:pane_idle)
+        assert_equal true, evidence.fetch(:work_observed)
+        assert_equal Hive::ClaudeLauncher.done_path(task), evidence.fetch(:expected_done_path)
+        assert_equal "hive-test-session", evidence.fetch(:session)
+      end
+    end
+  end
+
+  def test_wait_for_expected_output_remembers_busy_state_before_artifact_appears
+    with_tmp_task do |task|
+      output = File.join(task.folder, "result.md")
+      busy = "Claude Code v2\nworking…\n"
+      idle = "Claude Code v2\n\n/home/project  ❯"
+      runner = busy_then_idle_runner(busy, idle)
+      wrote_output = false
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :poll_interval, -> { 0.01 }) do
+        with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, lambda { |_seconds|
+          unless wrote_output
+            File.write(output, "review findings")
+            wrote_output = true
+          end
+        }) do
+          result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
+
+          assert_equal :completion_candidate, result.fetch(:status)
+          assert_equal true, result.fetch(:completion_evidence).fetch(:work_observed)
+        end
+      end
+    end
+  end
+
+  def test_wait_for_expected_output_ignores_cold_start_idle_without_work
     with_tmp_task do |task|
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
       runner = Struct.new(:tail) do
+        def session_exists? = true
         def capture_pane_tail(bytes:) = tail
-      end.new("Claude Code v2\n❯")
+      end.new("Claude Code v2\n\n/home/project  ❯")
 
-      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 1, output, "review")
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 0, output, "review")
 
-      assert_equal({ status: :ok, log_label: "review" }, result)
+      assert_equal :timeout, result.fetch(:status)
+      assert_match(/missing or empty/, result.fetch(:error_message))
     end
   end
 
@@ -1185,6 +1257,7 @@ class ClaudeLauncherTest < Minitest::Test
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:name) do
         def session_exists? = false
       end.new("gone-reviewer")
@@ -1224,6 +1297,126 @@ class ClaudeLauncherTest < Minitest::Test
       timeout = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci")
       assert_equal :timeout, timeout.fetch(:status)
       assert_match(/stop hook did not signal/, timeout.fetch(:error_message))
+      evidence = timeout.fetch(:completion_evidence)
+      assert_equal false, evidence.fetch(:sentinel_present)
+      assert_equal Hive::ClaudeLauncher.done_path(task), evidence.fetch(:expected_done_path)
+      assert_equal Hive::ClaudeLauncher.result_path(task), evidence.fetch(:expected_result_path)
+      assert_equal "deadline_without_stop_hook", evidence.fetch(:reason)
+    end
+  end
+
+  def test_wait_for_done_signal_rejects_missing_or_invalid_result_json
+    invalid_results = {
+      missing: nil,
+      empty: "",
+      malformed: "{",
+      non_hash: JSON.generate([ "not", "a", "hash" ]),
+      status_less: JSON.generate("hive_stop_hook" => "empty_stdin")
+    }
+
+    invalid_results.each do |label, body|
+      with_tmp_task do |task|
+        File.write(Hive::ClaudeLauncher.done_path(task), "done")
+        File.write(Hive::ClaudeLauncher.result_path(task), body) unless body.nil?
+
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, label.to_s)
+
+        assert_equal :error, result.fetch(:status), label.to_s
+        assert_match(/missing or invalid result\.json/, result.fetch(:error_message), label.to_s)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_returns_candidate_after_busy_to_idle
+    with_tmp_task do |task|
+      busy = "Claude Code v2.1.128\nworking…\n"
+      idle = "Claude Code v2.1.128\n\n/home/project  ❯"
+      runner = busy_then_idle_runner(busy, idle)
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :poll_interval, -> { 0.01 }) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "fix")
+
+        assert_equal :completion_candidate, result.fetch(:status)
+        assert_match(/stop hook did not signal/, result.fetch(:error_message))
+        evidence = result.fetch(:completion_evidence)
+        assert_equal true, evidence.fetch(:pane_idle)
+        assert_equal true, evidence.fetch(:work_observed)
+        assert_equal true, evidence.fetch(:session_alive)
+        assert_equal "turn_ended_without_stop_hook", evidence.fetch(:reason)
+        assert_equal "missing", evidence.fetch(:missing_signal_reason)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_ignores_cold_start_idle_before_work_starts
+    with_tmp_task do |task|
+      File.write(File.join(task.folder, ".lock"), { "claude_pid" => Process.pid }.to_yaml)
+      idle = "Claude Code v2.1.128\n\n/home/project  ❯"
+      runner = Struct.new(:tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new(idle)
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "fix")
+
+      assert_equal :timeout, result.fetch(:status)
+      evidence = result.fetch(:completion_evidence)
+      assert_equal "deadline_without_stop_hook", evidence.fetch(:reason)
+      refute_equal true, evidence.fetch(:work_observed)
+    end
+  end
+
+  def test_wait_for_done_signal_deadline_preserves_busy_state
+    with_tmp_task do |task|
+      runner = Struct.new(:tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("Claude Code v2.1.128\nstill working\n")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "fix")
+
+      assert_equal :timeout, result.fetch(:status)
+      evidence = result.fetch(:completion_evidence)
+      assert_equal false, evidence.fetch(:pane_idle)
+      assert_equal true, evidence.fetch(:session_alive)
+      assert_equal "deadline_without_stop_hook", evidence.fetch(:reason)
+    end
+  end
+
+  def test_wait_for_done_signal_evidence_handles_tmux_errors
+    with_tmp_task do |task|
+      runner = Struct.new(:tail) do
+        def session_exists?
+          raise Hive::TmuxError, "server disappeared"
+        end
+
+        def capture_pane_tail(bytes:)
+          raise Hive::TmuxError, "pane unreadable"
+        end
+      end.new
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "fix")
+
+      assert_equal :timeout, result.fetch(:status)
+      evidence = result.fetch(:completion_evidence)
+      assert_nil evidence.fetch(:pane_idle)
+      assert_equal false, evidence.fetch(:session_alive)
+      assert_equal "server disappeared", evidence.fetch(:session_error)
+    end
+  end
+
+  def test_completion_evidence_defensive_helpers_degrade_conservatively
+    with_tmp_task do |task|
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :claude_ready_prompt?, ->(_tail) { raise "bad pane" }) do
+        assert_nil Hive::ClaudeLauncher.completion_pane_idle?("Claude Code")
+      end
+
+      File.write(File.join(task.folder, ".lock"), "[")
+      assert_nil Hive::ClaudeLauncher.recorded_claude_pid(task)
+
+      with_replaced_singleton_method(Process, :kill, ->(_signal, _pid) { raise Errno::EPERM }) do
+        assert_equal true, Hive::ClaudeLauncher.process_alive?(12_345)
+      end
     end
   end
 
@@ -1256,6 +1449,7 @@ class ClaudeLauncherTest < Minitest::Test
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:tail) do
         def session_exists? = true
         def capture_pane_tail(bytes:) = tail
@@ -1269,6 +1463,7 @@ class ClaudeLauncherTest < Minitest::Test
 
     with_tmp_task do |task|
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:tail) do
         def capture_pane_tail(bytes:) = tail
       end.new(quoted_pane)
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 9d5471ad..3ecabbfc 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -48,6 +48,24 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_claude_completion_fallback_event_type_is_registered
+    with_tmp_dir do |dir|
+      record = Hive::Events.emit(
+        task_folder: dir,
+        slug: "fallback-test",
+        stage: "6-review",
+        agent: "phase=fix pass=01",
+        event_type: :claude_completion_fallback,
+        message: "level=warn phase=fix pass=01 task=fallback-test"
+      )
+      assert_equal "claude_completion_fallback", record.fetch("event_type")
+      assert_includes record.fetch("message"), "level=warn"
+
+      status = File.read(File.join(dir, "status.md"))
+      assert_includes status, "claude_completion_fallback"
+    end
+  end
+
   def test_status_md_rerenders_latest_event_and_recent_tail
     with_tmp_dir do |dir|
       Hive::Events.emit(task_folder: dir, slug: "event-test-260522-aaaa", stage: "6-review",
diff --git a/test/unit/reviewers/agent_test.rb b/test/unit/reviewers/agent_test.rb
index 241611ea..69314511 100644
--- a/test/unit/reviewers/agent_test.rb
+++ b/test/unit/reviewers/agent_test.rb
@@ -43,6 +43,25 @@ class ReviewersAgentTest < Minitest::Test
     }.merge(overrides)
   end
 
+  def completion_candidate(task_folder)
+    {
+      status: :completion_candidate,
+      error_message: Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+      completion_evidence: {
+        expected_done_path: File.join(task_folder, ".done"),
+        missing_signal_reason: "missing",
+        process_exited: false,
+        exit_code: nil,
+        session_alive: true,
+        session_error: nil,
+        tmux_readable: true,
+        pane_idle: true,
+        work_observed: true,
+        session: "reviewer-session"
+      }
+    }
+  end
+
   def test_run_returns_ok_when_agent_writes_expected_output_file
     with_tmp_dir do |dir|
       ctx = make_ctx(dir)
@@ -89,6 +108,29 @@ class ReviewersAgentTest < Minitest::Test
     end
   end
 
+  def test_completion_candidate_rejects_malformed_reviewer_artifact
+    with_tmp_dir do |dir|
+      ctx = make_ctx(dir)
+      FileUtils.mkdir_p(ctx.task_folder)
+      reviewer = Hive::Reviewers::Agent.new(make_spec("max_attempts" => 1), ctx)
+      candidate = completion_candidate(ctx.task_folder)
+      replacement = lambda do |_task, **kwargs|
+        File.write(kwargs.fetch(:expected_output), "agent stopped mid-sentence")
+        candidate
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_agent, replacement) do
+        result = reviewer.run!
+
+        assert result.error?
+        assert_match(/stop hook did not signal completion/, result.error_message)
+        refute File.exist?(reviewer.output_path)
+        events_path = File.join(ctx.task_folder, "events.jsonl")
+        refute File.exist?(events_path)
+      end
+    end
+  end
+
   # A8 fail-closed, REAL adapter path: a non-yolo permissions scope on a
   # reviewer whose runner can't enforce tool scoping (codex) must raise
   # Hive::ConfigError from the ACTUAL Reviewers::Agent#run! →
diff --git a/test/unit/stages/review/browser_test_test.rb b/test/unit/stages/review/browser_test_test.rb
index 5025f9cc..071d03f1 100644
--- a/test/unit/stages/review/browser_test_test.rb
+++ b/test/unit/stages/review/browser_test_test.rb
@@ -64,6 +64,25 @@ class BrowserTestTest < Minitest::Test
     end
   end
 
+  def completion_candidate(task_folder)
+    {
+      status: :completion_candidate,
+      error_message: Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+      completion_evidence: {
+        expected_done_path: File.join(task_folder, ".done"),
+        missing_signal_reason: "missing",
+        process_exited: false,
+        exit_code: nil,
+        session_alive: true,
+        session_error: nil,
+        tmux_readable: true,
+        pane_idle: true,
+        work_observed: true,
+        session: "browser-session"
+      }
+    }
+  end
+
   # --- skipped path ----------------------------------------------------
 
   def test_returns_skipped_when_disabled
@@ -99,6 +118,26 @@ class BrowserTestTest < Minitest::Test
     end
   end
 
+  def test_completion_candidate_rejects_json_object_without_browser_schema
+    with_browser_dir do |_dir, task_folder, ctx|
+      candidate = completion_candidate(task_folder)
+      replacement = lambda do |_task, _cfg, **kwargs|
+        File.write(kwargs.fetch(:expected_output), JSON.generate({}))
+        candidate
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::BrowserTest.run_attempt(
+          cfg: cfg_with, ctx: ctx, attempt: 1
+        )
+
+        assert_equal :failed, result.fetch(:status)
+        assert_match(/stop hook did not signal completion/, result.fetch(:error_message))
+        refute File.exist?(File.join(task_folder, "events.jsonl"))
+      end
+    end
+  end
+
   def test_returns_passed_when_second_attempt_succeeds_after_first_fails
     with_browser_dir do |dir, task_folder, ctx|
       attempt_count_file = File.join(dir, ".browser-attempts")
diff --git a/test/unit/stages/review/ci_fix_test.rb b/test/unit/stages/review/ci_fix_test.rb
index f94c81a6..9eabc492 100644
--- a/test/unit/stages/review/ci_fix_test.rb
+++ b/test/unit/stages/review/ci_fix_test.rb
@@ -74,6 +74,25 @@ class CiFixTest < Minitest::Test
     end
   end
 
+  def completion_candidate(task_folder)
+    {
+      status: :completion_candidate,
+      error_message: Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+      completion_evidence: {
+        expected_done_path: File.join(task_folder, ".done"),
+        missing_signal_reason: "missing",
+        process_exited: false,
+        exit_code: nil,
+        session_alive: true,
+        session_error: nil,
+        tmux_readable: true,
+        pane_idle: true,
+        work_observed: true,
+        session: "ci-fix-session"
+      }
+    }
+  end
+
   # --- skipped ----------------------------------------------------------
 
   def test_returns_skipped_when_command_is_nil
@@ -175,6 +194,27 @@ class CiFixTest < Minitest::Test
     end
   end
 
+  def test_completion_candidate_rejects_unreadable_git_state
+    with_ci_dir do |dir, task_folder|
+      ci = write_ci_script(dir, "echo fail >&2\nexit 1")
+      cfg = cfg_with(ci, "review" => { "ci" => { "max_attempts" => 2 } })
+      candidate = completion_candidate(task_folder)
+      replacement = ->(_task, _cfg, **_kwargs) { candidate }
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::CiFix.run!(
+          cfg: cfg,
+          ctx: make_ctx(dir, task_folder)
+        )
+
+        assert_equal :error, result.status
+        assert_match(/worktree state unreadable/, result.error_message)
+        assert_match(/rev-parse failed/, result.error_message)
+        refute File.exist?(File.join(task_folder, "events.jsonl"))
+      end
+    end
+  end
+
   def test_returns_error_when_fix_agent_tampers_with_protected_task_files
     with_tmp_dir do |task_root|
       with_tmp_git_repo do |worktree|
diff --git a/test/unit/stages/review/triage_test.rb b/test/unit/stages/review/triage_test.rb
index 4d4aee70..25af1557 100644
--- a/test/unit/stages/review/triage_test.rb
+++ b/test/unit/stages/review/triage_test.rb
@@ -65,6 +65,25 @@ class TriageTest < Minitest::Test
     end
   end
 
+  def completion_candidate(task_folder)
+    {
+      status: :completion_candidate,
+      error_message: Hive::ClaudeCompletionFallback::STOP_HOOK_ERROR_MESSAGE,
+      completion_evidence: {
+        expected_done_path: File.join(task_folder, ".done"),
+        missing_signal_reason: "missing",
+        process_exited: false,
+        exit_code: nil,
+        session_alive: true,
+        session_error: nil,
+        tmux_readable: true,
+        pane_idle: true,
+        work_observed: true,
+        session: "triage-session"
+      }
+    }
+  end
+
   # --- empty inputs ------------------------------------------------------
 
   def test_empty_reviewer_files_writes_empty_escalations_doc
@@ -80,6 +99,54 @@ class TriageTest < Minitest::Test
     end
   end
 
+  def test_completion_candidate_rejects_malformed_escalations_artifact
+    with_triage_dir do |dir, task_folder|
+      ctx = make_ctx(dir, task_folder)
+      File.write(File.join(task_folder, "reviews", "claude-ce-code-review-01.md"),
+                 "## High\n- [ ] finding: details\n")
+      candidate = completion_candidate(task_folder)
+      replacement = lambda do |_task, _cfg, **kwargs|
+        File.write(kwargs.fetch(:expected_output), "not an escalations document")
+        candidate
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::Triage.run!(cfg: default_cfg, ctx: ctx)
+
+        assert_equal :error, result.status
+        assert_match(/stop hook did not signal completion/, result.error_message)
+        refute File.exist?(result.escalations_path)
+        refute File.exist?(File.join(task_folder, "events.jsonl"))
+      end
+    end
+  end
+
+  def test_completion_candidate_accepts_parsed_escalations_for_synthetic_task
+    with_triage_dir do |dir, task_folder|
+      ctx = make_ctx(dir, task_folder)
+      File.write(File.join(task_folder, "reviews", "claude-ce-code-review-01.md"),
+                 "## High\n- [ ] finding: details\n")
+      candidate = completion_candidate(task_folder)
+      replacement = lambda do |_task, _cfg, **kwargs|
+        File.write(kwargs.fetch(:expected_output),
+                   "# Escalations for pass 01\n\n_All findings resolved. No user questions._\n")
+        candidate
+      end
+
+      with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, replacement) do
+        result = Hive::Stages::Review::Triage.run!(cfg: default_cfg, ctx: ctx)
+
+        assert_equal :ok, result.status
+        event = File.readlines(File.join(task_folder, "events.jsonl"), chomp: true)
+                    .map { |line| JSON.parse(line) }
+                    .find { |row| row["event_type"] == "claude_completion_fallback" }
+        refute_nil event
+        assert_includes event.fetch("message"), "task=test-task"
+        assert_includes event.fetch("message"), "session=triage-session"
+      end
+    end
+  end
+
   # --- happy path: courageous --------------------------------------------
 
   def test_courageous_mode_renders_template_and_consumes_reviewer_files
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57a..7f014027 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -70,6 +70,35 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_install_rolls_back_earlier_settings_when_later_cwd_install_fails
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir do |cwd|
+        stage_claude_dir = File.join(stage_dir, ".claude")
+        FileUtils.mkdir_p(stage_claude_dir)
+        stage_settings = File.join(stage_claude_dir, "settings.json")
+        original_body = JSON.generate("enabledPlugins" => { "project" => true })
+        File.write(stage_settings, original_body)
+        original_install_at = Hive::StopHookInstaller.method(:install_at)
+
+        replacement = lambda do |target_dir, signal_dir|
+          raise Errno::EACCES, target_dir if File.expand_path(target_dir) == File.expand_path(cwd)
+
+          original_install_at.call(target_dir, signal_dir)
+        end
+
+        with_replaced_singleton_method(Hive::StopHookInstaller, :install_at, replacement) do
+          assert_raises(Errno::EACCES) do
+            Hive::StopHookInstaller.install(stage_dir: stage_dir, extra_dirs: [ cwd ])
+          end
+        end
+
+        assert_equal original_body, File.read(stage_settings)
+        refute File.exist?("#{stage_settings}#{Hive::StopHookInstaller::BACKUP_SUFFIX}")
+        refute File.exist?(File.join(cwd, ".claude", "settings.json"))
+      end
+    end
+  end
+
   def test_install_skips_extra_dir_equal_to_stage_dir
     with_tmp_dir do |dir|
       paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ dir ])
@@ -137,6 +166,48 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_stop_hook_empty_stdin_writes_forensic_json_before_done
+    with_tmp_dir do |dir|
+      out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "")
+
+      assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+      data = JSON.parse(File.read(File.join(dir, "result.json")))
+      assert_equal "empty_stdin", data.fetch("hive_stop_hook")
+      assert File.exist?(File.join(dir, ".done"))
+    end
+  end
+
+  def test_divergent_cwd_hook_writes_only_task_folder_signals
+    require "hive/claude_launcher"
+    with_tmp_dir do |task_dir|
+      Dir.mktmpdir do |cwd|
+        paths = Hive::StopHookInstaller.install(stage_dir: task_dir, extra_dirs: [ cwd ])
+        assert_equal 2, paths.size
+
+        # Path contract: launcher helpers and hook both target task_dir.
+        task = Struct.new(:folder).new(task_dir)
+        assert_equal File.join(task_dir, ".done"), Hive::ClaudeLauncher.done_path(task)
+        assert_equal File.join(task_dir, "result.json"), Hive::ClaudeLauncher.result_path(task)
+
+        cwd_settings = File.join(cwd, ".claude", "settings.json")
+        command = JSON.parse(File.read(cwd_settings))
+                      .fetch("hooks").fetch("Stop").first
+                      .fetch("hooks").first.fetch("command")
+        assert_includes command, "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(task_dir)}"
+
+        # Invoke the cwd-discovered hook; signals land only in task_dir.
+        payload = %({"session_id":"cwd-divergent"})
+        out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => task_dir }, HOOK, stdin_data: payload)
+        assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+
+        assert_equal payload, File.read(Hive::ClaudeLauncher.result_path(task))
+        assert File.exist?(Hive::ClaudeLauncher.done_path(task))
+        refute File.exist?(File.join(cwd, ".done"))
+        refute File.exist?(File.join(cwd, "result.json"))
+      end
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
